"""
File: main.py
Purpuse: Main module of the game
Tab Width: 4
Revision: $Id: main.py 544 2006-04-02 01:35:56Z nirh $
"""

### Imports ###
import pygame
import game
import level
import mouse
import Options
import sound
import steams
import sys

### Code ###

def runGame(arguments):
	pygame.display.init()
	pygame.font.init()
		
	pygame.display.set_caption('Steamer Game')
	flags = pygame.DOUBLEBUF | pygame.OPENGL # | pygame.RESIZABLE | HWSURFACE
	if '-f' in arguments:
		flags |= pygame.FULLSCREEN
	window = pygame.display.set_mode((Options.WindowWidth,Options.WindowHeight),flags)
	screen = pygame.display.get_surface()
	
	# Initialize modules
	steams.InitSteam()
	mouse.InitMouse()
	sound.initSound()
	
	def doLevel(level):
		game.g_currentLevel = currentLevel
		currentLevel.start()
		while currentLevel.isActive():
			events = pygame.event.get()
			if [] == events:
				pygame.event.post(pygame.event.Event(pygame.VIDEOEXPOSE,{}))
			else:
				currentLevel.handleEvents(events)
	
	try:
		Score = 0
		for currentLevel in game.getGameScreens():
			doLevel(currentLevel)
			Score += currentLevel.highScore
		import halloffame
		currentLevel = halloffame.HallOfFameScreen(Score)
		doLevel(currentLevel)
	except game.EndGameException:
		pass
	
	pygame.quit()

if __name__ == '__main__':
	# Psyco acceleration
	try:
		import psyco
		psyco.profile()
	except ImportError:
		pass

	runGame(sys.argv)
